/* SPDX-FileCopyrightText: 2023-2026 Sayantan Santra <sayantan.santra689@gmail.com> */
/* SPDX-License-Identifier: MIT */

@import url("https://fonts.googleapis.com/css2?family=Montserrat&display=swap");
@font-face {
  font-family: Montserrat, "Open Sans", Helvetica, Arial, sans-serif;
  font-optical-sizing: auto;
  font-weight: 400;
  font-style: normal;
  font-display: swap;
}

:root {
  color-scheme: light dark;
  font-family: Montserrat;
  /* Colors */
  --text: light-dark(black, #e8e6e3);
  --bg: light-dark(white, #181a1b);
  --link: light-dark(blue, #3391ff);
  --accent: light-dark(#0078e7, #0060b9);
  --border: light-dark(#cccccc, #3e4446);
  --shadow: light-dark(#dddddd, #2b2f31);
  --muted: light-dark(#757575, #636061);
  --logo: light-dark(#333333, #c8c3bc);
  --logo-border: light-dark(#e5e5e5, #373c3e);
  --table: light-dark(#e0e0e0, #2a2d2f);
  --row-bg: light-dark(#f2f2f2, #080a0b);
  --row-alt-bg: light-dark(#f2f2f2, #101213);
  --row-hover: light-dark(rgba(150, 225, 250, 0.3), rgba(35, 225, 250, 0.1));
  --warning: light-dark(red, #ff1a1a);
  --warning-button: light-dark(#dd1a1a, #901010);
  --accent-border: light-dark(black, #867d6e);
  --tooltip: light-dark(#eeeeee, #484a4b);
  --tooltip-bg: light-dark(white, #2b2a33);
  --button-hover: light-dark(#eeeeee, #2b2a33);
}
body {
  color: var(--text);
  background-color: var(--bg);
}
.container {
  max-width: 80em;
  margin: 2em auto auto;
}

.chhoto-button {
  background-color: var(--accent);
}
.chhoto-button:hover,
.linkButton:hover {
  transform: scale(1.05);
}
.pure-form input.chhoto-input {
  width: 65%;
  border-color: var(--border);
  box-shadow: var(--shadow) 0 0.1em 0.2em inset;
}
.pure-form input.chhoto-input:focus {
  border-color: var(--border);
}

#logo,
.chhoto-table th,
.chhoto-table td,
span[name="label"] {
  user-select: none;
  -webkit-user-select: none; /* Safari */
}

#expiryDelay {
  background-color: var(--tooltip-bg);
  border-color: var(--border);
  box-shadow: var(--shadow) 0 0.1em 0.2em inset;
}

::placeholder {
  color: var(--muted);
}

#logo {
  color: var(--logo);
  border-bottom-color: var(--logo-border);
  font-size: 2em;
}
#logo img {
  height: 0.8em;
  transition: filter 0.1s ease;
}
#logo img:hover {
  filter: drop-shadow(
      0 0 10px color-mix(in srgb, var(--accent) 45%, transparent)
    )
    drop-shadow(0 0 14px color-mix(in srgb, var(--accent) 25%, transparent));
}

a {
  color: var(--link);
  text-decoration: none;
}
.linkButton {
  display: inline-flex;
  align-items: center;
  gap: 0.2em;
  height: 2em;
  padding: 0 0.5em;
  border: 0.1em solid var(--accent-border);
  border-radius: 0.3em;
  background: transparent;
  color: var(--text);
  text-decoration: none;
  cursor: pointer;
  box-sizing: border-box;
  margin-left: 0.2em;
}
.linkButton:hover {
  background: var(--button-hover);
}

.chhoto-table {
  width: 98%;
  border-collapse: separate;
  border-spacing: 0;
  border-radius: 0.3em;
  box-shadow: 0 0 0 0.1em var(--table);
  border-color: var(--accent-border);
}
.chhoto-table tr td div {
  max-height: 4.5em;
  line-height: 1.5em;
  word-break: break-word;
  display: -webkit-box;
  -webkit-line-clamp: 2;
  -webkit-box-orient: vertical;
  overflow: hidden;
  text-overflow: ellipsis;
}
.chhoto-table tr td[label="Long URL"] div {
  word-break: break-all;
  color: var(--link);
}
.chhoto-table tr td[name="numColumn"] div {
  word-break: normal;
}
.chhoto-table tr td[name="hitsColumn"] div {
  word-break: normal;
}
.chhoto-table tr:nth-child(even) {
  background-color: var(--row-bg);
}
.chhoto-table caption {
  color: var(--text);
  text-align: left;
  font-size: 1.5em;
  font-style: normal;
  font-family: Montserrat;
  padding: 0em;
}
.chhoto-table thead {
  color: var(--text);
  background-color: var(--table);
}
.chhoto-table th,
.chhoto-table td {
  border-left: none;
  max-width: 36em;
}
#table-box tr {
  transition: background-color 0.3s ease;
}
#table-box tr:hover:has(td) {
  background-color: var(--row-hover);
}

#short-url-header {
  min-width: 10em;
}

#filter-div {
  min-width: 20em;
  font-size: 0.7em;
  float: right;
  text-align: right;
}
#filter-div fieldset {
  display: flex;
  justify-content: flex-end;
  gap: 0.3em;
}

#controls,
#optionsSection summary {
  margin-top: 1em;
}
#optionsSection[open] summary {
  margin-bottom: 1em;
}

th[name="hitsColumn"],
td[name="hitsColumn"] {
  text-align: right;
}

th[name="expiryColumn"],
td[name="expiryColumn"] {
  text-align: center;
}

th[name="actions"],
td[name="actions"] div {
  align-items: center;
  justify-items: center;
  text-align: center;
  width: 12em;
}
td[name="actions"] div button,
.pure-table caption button.svg-button {
  aspect-ratio: 1;
  border-style: none;
  cursor: pointer;
  display: table-cell;
  vertical-align: middle;
  background-color: transparent;
}
td[name="actions"] div button.svg-button svg,
.pure-table caption button.svg-button svg {
  height: 1.3em;
}

.svg-button:enabled:hover svg {
  transform: scale(1.2);
}

.pure-table caption span {
  margin-right: 1em;
}
.pure-table caption span[name="label"] {
  display: inline-block;
  margin: 0.2em 1em 0.4em 0em;
}

form input[name="shortUrl"]::placeholder {
  text-transform: none;
}

div[name="links-div"] {
  position: absolute;
  right: 0.5%;
  top: 0.5%;
}

details.chhoto-input summary {
  cursor: pointer;
}
summary,
.svg-button {
  -webkit-tap-highlight-color: transparent;
}

#password {
  width: 100%;
  margin-bottom: 1em;
}
#wrong-pass {
  color: var(--warning);
}

.chhoto-dialog {
  border-radius: 1em;
  border-width: 0.15em;
  max-width: 40em;
}
#info-dialog,
#edit-dialog {
  min-width: 25vw;
}
#login-dialog div {
  position: relative;
}
#password-eye-button {
  position: absolute;
  right: 0.1em;
  top: 1.3em;
  transform: translateY(-50%);
  background-color: transparent;
  border-style: none;
  cursor: pointer;
  -webkit-tap-highlight-color: rgba(0, 0, 0, 0);
}

#edit-dialog form,
#login-dialog form {
  text-align: center;
}
#edit-cancel-button {
  background-color: var(--warning-button);
}
#edit-dialog label {
  max-width: 5em;
  margin-right: 0em;
}
#edit-dialog label[for="edit-checkbox"] {
  max-width: 100%;
}
#edit-buttons {
  margin-top: 0.5em;
}

#alert-box {
  padding: 0.5em;
  border-radius: 0.3em;
  margin-top: 0.2em;
  width: fit-content;
}

#qr-code-dialog {
  background-color: white;
  border-color: grey;
  text-align: right;
}
#qr-code-dialog div {
  margin: 0.5em;
}
#qr-code canvas {
  max-width: min(20em, 80vw);
}
.dialog-close-button {
  background-color: transparent;
  border-style: none;
  position: absolute;
  top: 0.3em;
  right: 0.3em;
  cursor: pointer;
}
.dialog-close-button svg {
  height: 2em;
}
#qr-download-button {
  right: 2em;
  text-decoration: none;
}
#qr-code-dialog svg,
#qr-code-dialog svg {
  color: black;
}

#info-div {
  margin: 0.5em 0.5em 0.2em 0.5em;
}
#info-table,
#info-table tr td {
  border: none;
  padding-top: 0.1em;
}
#info-table tr td:first-child {
  font-weight: bold;
}
#info-table tr td:last-child {
  word-break: break-all;
}

.tooltip {
  position: relative;
}
.tooltip span {
  cursor: pointer;
}
.tooltip .tooltiptext {
  visibility: hidden;
  width: 8em;
  background-color: var(--tooltip);
  color: var(--text);
  text-align: center;
  padding: 0.3em 0;
  border-radius: 0.4em;
  position: absolute;
  z-index: 1;
  bottom: calc(50% + 1.25em);
  left: 50%;
  margin-left: -4em;
  opacity: 0;
  transition: opacity 0.3s;
}
.tooltip .tooltiptext::after {
  content: "";
  position: absolute;
  top: 100%;
  left: 50%;
  margin-left: -0.3em;
  border-width: 0.3em;
  border-style: solid;
  border-color: var(--tooltip) transparent transparent transparent;
}
.tooltip span:hover + .tooltiptext {
  visibility: visible;
  opacity: 1;
}

/* Settings for mobile devices */
@media (max-width: 768px) {
  .container {
    max-width: 98vw;
  }
  .pure-form input.chhoto-input {
    width: 98%;
  }

  #version-number {
    margin-right: 0.3em;
  }
  .chhoto-table {
    border-collapse: collapse;
    border: none;
    box-shadow: none;
  }
  .chhoto-table tr:first-child {
    border-top: 0.15em dotted var(--accent-border);
  }
  .chhoto-table tr:not(:last-child) {
    border-bottom: 0.15em dotted var(--accent-border);
  }
  .chhoto-table tr:nth-child(odd) {
    background-color: var(--row-alt-bg);
  }
  .chhoto-table tr:nth-child(even) {
    background-color: inherit;
  }

  .chhoto-table thead {
    display: none;
  }

  .chhoto-table td {
    display: flex;
    justify-content: left;
    width: 97vw;
    padding: 0.1em;
  }

  .chhoto-table tr td[name="shortColumn"] {
    padding-top: 0.5em;
  }
  .chhoto-table tr td[name="actions"] {
    padding-bottom: 0.5em;
  }
  .chhoto-table tr td[name="actions"] div {
    text-align: left;
    margin-left: -0.5em;
  }

  #alert-box {
    display: none;
  }

  #filter-div {
    width: 100%;
  }
  #filter-div fieldset {
    display: flex;
    align-items: center;
    gap: 0.3em;
  }
  #filterText,
  #filter-div button {
    box-sizing: border-box;
    min-height: 2.4em;
    margin: 0;
  }
  #filter-div button {
    display: inline-flex;
    align-items: center;
    justify-content: center;
    white-space: nowrap;
  }

  .chhoto-table td::before {
    content: attr(label);
    font-weight: bold;
    min-width: 6em;
    text-align: left;
    align-content: center;
  }
  .chhoto-table td div {
    align-content: center;
  }

  .chhoto-table th[name="numColumn"],
  .chhoto-table td[name="numColumn"] {
    display: none;
  }

  .tooltip .tooltiptext {
    left: 8em;
  }
}
